/*******************************************************************/
/*                           KEYWF.C                               */
/*          Sucht in Text-Dateien nach Schluesselwoertern          */
/*-----------------------------------------------------------------*/
/* Bei Aufruf ohne Parameter:                                      */
/* Wird in einer Zeile ein Schluesselwort gefunden, wird die       */
/* entsprechende laufende Nummer des Schluesselwortes ausgegeben.  */
/* Eine weitere Suche in der gleichen Zeile und nach dem gleichen  */
/* Schluesselwort erfolgt aus Geschwindigkeitsgruenden nicht mehr! */
/* Schluesselworte in Binaerdateien werden nicht gefunden, bzw.    */
/* nur dann, wenn noch keine Steuerzeichen gelesen wurden.         */
/* Die Schluesselworte werden normalerweise aus der Tabelle        */
/* SCANTAB ausgelesen. Es ist aber auch moeglich beim Aufruf ein   */
/* einzelnes Schluesselwort mitzugeben. Dann wird nur nach diesem  */
/* gesucht und "Treffer-Zeilen-Inhalte" ausgegeben.	           */
/* Werden 2 Zusatzparameter mitgegeben: Erfolgt nur die Ausgabe    */
/* der Filenamen mit --> und Zeilenvorschub                        */
/* Hierbei gibt es einen Spezialfall, das Schluesselwort CHECK.    */
/* Durch CHECK werden die aus SCANTAB eingelesenen Schluesselworte */
/* ausgegeben, um die Tabelle auf Korrektheit zu pruefen!          */
/* Um die Geschwindigkeit zu erhoehen, wird bei erreichen von      */
/* von MaxAnzahl die Leseschleife "while (fgets...) durch break    */
/* verlassen.                                                      */
/* Das Programm wurde geschrieben, um auf Packet Radio Dateien mit */
/* "Ferkeleien" automatisch zu finden. Im Gegensatz zu anderen     */
/* "Suchern" erlaubt dieses Programm eine multiple-choice Suche,   */
/* also die Suche nach mehreren Schluesselwoertern gleichzeitig.   */
/* Fuer andere Anwendungen ist das Programm GREP evtl. besser ge-  */
/* geeignet!                                                       */
/*                                                                 */
/*                       Autor: Lothar Miedel                      */
/*           Das Prg ist RPD = Real Public Domain                  */
/*    Eigentlich kann ich noch gar kein C, bin noch am Lernen!     */
/*    Aber: Hauptsache das Programm macht das, was man will.       */
/*******************************************************************/

#define VERSION "1.07"
#define DATE "Date: 04.09.92"
#define AUTOR "Author: DL2MBT"
#define LMSign1 "             "
#define LMSign2 "           "
#define LMSign3 "         "
#define LMSign4 "         "
#define LMSign5 "        "
#define LMSign6 "            "
#define WHAT "KEYWF "
#define job " Checks for Keywords depending on SCANTAB or direct"
#define PDZ "  -  PRG is RPD = Real Public Domain"
#define hinweiszeil "->   Tells file names with keyword(s) inside "

#define CHECK "CHECK"
#define KEYWANZ 50  /* Anzahl der Schluesselworte */
#define KEYWLEN 25
#define MaxAnzahl 3 /* Die ausgegebene Anzahl ist bei
		       Mehrfachtreffern hoeher!
		       Falls also in scantab beispielsweise
			  herum
			  rum
			  serum
			  gerumpel
		       stehen, tritt dieser Effekt auf.
		       */
#define TRUE 1
#define FALSE 0


#include "dos.h"
#include "stdio.h"
#include "string.h"
#include "conio.h"
#include "dir.h"

int i,KeyWordAnzahl;

char suchkrit[]="*.*"; /* Kann auch beispielsweise in *.TXT geaendert
			  werden; sucht dann in allen *.TXT des aktuellen
			  Verzeichnisses */
char scandatei[35]="SCANTAB"; /* Festlegung des Tabellennamens */
char lesedatei[15]; /* = Das immer aktuelle Lesefile */
char keyword[KEYWANZ][KEYWLEN]; /* Array-Festlegung fuer Keywords */
char rc[255]; /* Lesestring, auch rc[80] koennte ausreichen!! */

FILE *fr,*kt;                 /* fr = aktives Lesefile , kt = Tabelle */

/*---------------------------------------------------------------------*/
void LMAusgabe()
{ printf("%s   %s  %s    %s\n",LMSign1,WHAT,VERSION,DATE);
  printf("%s   %s  %s      \n",LMSign2,AUTOR,PDZ);
  printf("%s        \n",LMSign3);
  printf("%s   %s \n",LMSign4,hinweiszeil);
  printf("%s   JOB:%s \n",LMSign5,job);
  printf("%s        \n",LMSign6);
  }

/*--------------------------------------------------------------------*/
void scantaboeffnen()   /* SCANTAB zum Lesen oeffnen */
{
if ((kt = fopen(scandatei,"r+t")) == NULL)
  {
  printf("Error Open Keyword-Table %s\n",scandatei);
  exit(100);
  }
}
/*--------------------------------------------------------------------*/
void tabcheck()    /* Keywords zur Ueberpruefung auf Korrektheit ausgeben */
{    int i;
     printf("Keywords: \n");
     for (i=0; i != KeyWordAnzahl;i++)
      {
      printf("%s",keyword[i]);
      if (i != KeyWordAnzahl-1) printf(", ");
      }
   exit(100);
}
/*---------------------------------------------------------------------*/
void scantablesen()  /* Alle Keywords einlesen */
{ int j;  /* Bei int j,i=0; 24 Byte laengeres EXE-File */
  int i =0;
while(fgets(keyword[i],255,kt))
   {

    keyword[i][strlen(keyword[i])-1]=0; /* Muss wegen Tabelle sein! */

    for (j=0;j<=strlen(keyword[i]);j++)
      {
      if (strcmp(keyword[i][j],' ')==0)     /* Spaces am Keywort-Ende   */
	 {                                 /* zum Stringende machen    */
	 keyword[i][j]=0;                 /* gleichzeitig lfd. Nummer */
	 }                               /* abtrennen.               */
      }

  if (strpbrk(keyword[i],"BREAK")!=0) break; /* Um Tabelle abzukuerzen */


  strupr(keyword[i]);                  /* Wandeln in Grossbuchstaben */

  i++;  KeyWordAnzahl=i; /* Keyword-Zaehler mitlaufen lassen */
  }
 }

/*---------------------------------------------------------------------*/
void leseoeffnen()    /* Die jeweils ueber findfirst/findnext gefundene
		    Datei oeffnen */
{
if ((fr = fopen(lesedatei,"r+t")) == NULL)
  {
  printf("Error Open Readfile: %s\n",lesedatei);
  exit(100);
  }
}
/*---------------------------------------------------------------------*/
void oeffnenundlesen()
{
  scantaboeffnen();
  scantablesen();
}

/*---------------------------------------------------------------------*/
void schliessen()            /* Programm beenden */
{
  fclose(fr);
  printf("%s%s done.",WHAT,VERSION);
  exit(1);
}
/*---------------------------------------------------------------------*/
/***********************************************************************/
void main(int argc, char **argv)
{
  int j,lastentry,Name_schon_ausgegeben,hit;
  struct ffblk fblock;

  LMAusgabe();

  if (strcmp(strupr(argv[1]),CHECK) == 0)
    {
    oeffnenundlesen();
    tabcheck();   /* Falls Aufruf mit CHECK erfolgt: Keywords wie
		     gelesen und angepasst, ausgeben. Programm beenden */
    }

  if(!argv[1])    /* Kein zusaetzlicher Parameter mitgegeben */
    {
    oeffnenundlesen();
    }
   else           /* Parameter mitgegeben */
    {
   KeyWordAnzahl =1; /* Nur erster Parameter zugelassen */
   strcpy(keyword[0],argv[1]); /* Parameter zu keyword machen */
    }

  lastentry = findfirst(suchkrit,&fblock,0); /* Alle Files durchsuchen */
  while (!lastentry)  /* Noch nicht letztes File */
   {
   if (strcmp(fblock.ff_name,scandatei)==0)  /* SCANTAB unterdruecken */
     {                         /*SCANTAB wird nur gecheckt, wenn letzte */
     lastentry = findnext(&fblock); /* Datei in lastentry, da dann keine
				       naechste Datei */
     }
   Name_schon_ausgegeben = FALSE;
   strcpy(lesedatei,fblock.ff_name); /* Name der akt. Datei umkopieren */
   leseoeffnen();
   hit =0; /* Noch kein Treffer, also Treffer-Nullstellung  */
   while  (fgets(rc,255,fr)) /* Solange noch Text gelesen werden kann */
     {
     if (hit == MaxAnzahl){ break;}  /* Zur Temposteigerung koennte hier
					auf "switch case" umgebaut werden */
      strupr(rc); /* gelesenen String in Grossbuchstaben wandeln */
	j= 0;
	while (KeyWordAnzahl != j) /* Alle Keywords "abfahren" */
	{
	if(strstr(rc,keyword[j]) != 0) /* Auf Treffer pruefen */
		  {            /* Treffer ! */
		    if (Name_schon_ausgegeben != TRUE)
			{
			 printf("%13s --> ",lesedatei);
			 if (argc>>1) printf("\n");
			} /* if (Name ...) */
		    Name_schon_ausgegeben = TRUE;
		    if(argc==1)
		    printf("%2d ",j+1);     /* "Treffer-Nummern" ausgeben */
		    if(argc==2) {printf("%s",rc);} /* Bei Zusatz-Parameter
							 verdaechtige
							 Zeilen ausgeben */
		    hit++;
		  }  /* if(strstr(....) */
	   j++;
	} /* While (KeyWordAnzahl ..) */
     }  /* While (fgets.....) */
   if (Name_schon_ausgegeben==TRUE && argc==1) printf("\n");
   fclose(fr);
   lastentry = findnext(&fblock);
   }  /* While (!lastentry...) */
} /* main */
